/* Copyright fractalite */
(function () {
'use strict';
// Source: src/html/scripts/landing-pages-admin/landing-page-edit.js
angular.module('pine.blocks.pages', ['ui.sortable'])
    .controller('LandingPageEditCtrl', function ($scope) {

        var options = $scope.options;

        $scope.setRegion = function (b, r) {
            b.region = r;
            delete $scope.block;
        }
        $scope.unsetRegion = function (b) {
            b.region = null;
        }

        $scope.addBlock = function (block, region) {
            var index = options.blocks.indexOf(block);
            if (index > -1) {
                region.blocks = region.blocks || [];
                region.blocks.push(options.blocks.splice(index, 1)[0]);
            }
        }

        $scope.removeBlock = function (block, region) {
            var index = region.blocks.indexOf(block);
            if (index > -1) {
                options.blocks.push(region.blocks.splice(index, 1)[0]);
            }
        }

        $scope.dragListeners = {
            accept: function (sourceItemHandleScope, destSortableScope) {
                //console.log('accept', sourceItemHandleScope, destSortableScope);
                return true;
            }, //override to determine drag is allowed or not. default is true.
            itemMoved: function (event) { //Do what you want

            },
            additionalPlaceholderClass: 'list-group-item disabled',
            containment: '#landing-page-regions-edit',
            containerPositioning: 'relative'
        };



        console.log("LandingPageEditCtrl");

        $scope.$watch('copy.layout', function (fresh, old) {
            console.log("copy.layout", fresh, old);
            if (!fresh || fresh === old) return;
            for (var k in fresh) {
                fresh.blocks = fresh.blocks || [];
            }
        });

        $scope.$on('landing-page save', function (copy) {

            copy.blocks = copy.layout.regions.reduce(function (reduced, region) {
                var block;
                for (var i = 0; i < region.blocks.length; i++) {
                    reduced.push({
                        _id: region.blocks[i]._id,
                        region: region.id,
                        position: i
                    })
                };
                return reduced;

            }, []);

            console.log(copy.blocks);

        })


    });
}());